using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using Umdf.ComInterop;
using Umdf;

namespace Umdf.SideShow
{

    //[Guid("AB97FBD2-4F91-401b-A17E-0D709483FE99")]
    //[ComVisible(true)]
    public class DriverEntry<T, R> : IDriverEntry where T : SideShowDevice<R>, new() where R : SideShowDriver, new()
    {
        private T _device;
        //private IntPtr _deviceCallback;

        #region IDriverEntry Members

        public void OnDeinitialize(IWDFDriver pWdfDriver)
        {
            
        }

        public void OnDeviceAdd(IWDFDriver pWdfDriver, IWDFDeviceInitialize pWdfDeviceInit)
        {
            _device = new T();
            IWDFDevice wdfDevice = null;
            pWdfDriver.CreateDevice(pWdfDeviceInit, _device, out wdfDevice);
            SideShowQueue<T, R> q = new SideShowQueue<T, R>(_device);
            IWDFIoQueue defaultQueue = null;
            wdfDevice.CreateIoQueue(q, 1, _WDF_IO_QUEUE_DISPATCH_TYPE.WdfIoQueueDispatchSequential, 1, 0, out defaultQueue);

        }

        public void OnInitialize(IWDFDriver pWdfDriver)
        {
            
        }

        #endregion
    }
}