using System;
using System.Collections.Generic;
using System.Text;

namespace Umdf.SideShow.Properties
{
    [AttributeUsage(AttributeTargets.Class, AllowMultiple=false, Inherited=false)]
    public class PropertyIdAttribute : Attribute
    {
        private Guid _formatId;
        private int _pid;

        public PropertyIdAttribute(string formatId, int pid)
        {
            _formatId = new Guid(formatId);
            _pid = pid;
        }

        public Guid FormatId
        {
            get { return _formatId; }
        }

        public int Pid
        {
            get { return _pid; }
        }
    }
}
