using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace SideShow.Contents
{
    [Serializable]
    public class UnknownContent : Content
    {
        private byte[] _data;

        public UnknownContent()
        {
        }

        public UnknownContent(uint id, byte[] data) : base(id)
        {
            _data = data;
        }

        public byte[] Data
        {
            get { return _data; }
        }

        public override void Save(string dir)
        {
            string filename = Path.Combine(dir, Id.ToString() + ".dat");
            using (FileStream fs = File.Create(filename))
            {
                fs.Write(_data, 0, _data.Length);
            }
        }

        protected internal override void DeserializeObject(BinaryReader reader)
        {
            base.DeserializeObject(reader);
            int l = reader.ReadInt32();
            _data = reader.ReadBytes(l);
        }

        protected internal override void SerializeObject(BinaryWriter writer)
        {
            base.SerializeObject(writer);
            writer.Write(_data.Length);
            writer.Write(_data);
        }
    }
}
