using System;
using System.Collections.Generic;
using System.Text;
using SideShow;
using SideShow.Channel;


namespace TestApp
{
    class ClientApp : IServerChannel
    {
        #region IPocketPCChannel Members

        public void AddApplication(SideShowApplication app)
        {
            Console.WriteLine("Application added");
            Console.WriteLine(app.Name);
            Console.WriteLine(app.Id);
        }

        public void AddContent(Guid applicationId, Guid sideShowEndpointId, SideShow.Contents.Content newContent)
        {
            Console.WriteLine("Content added");
            Console.WriteLine(applicationId);
            Console.WriteLine(sideShowEndpointId);
            Console.WriteLine(newContent.Id);
        }

        public void RemoveApplication(Guid appId)
        {
            Console.WriteLine("Application removed");
            Console.WriteLine(appId);
        }

        public void RemoveContent(Guid applicationId, Guid sideShowEndpointId, uint removedContentId)
        {
            Console.WriteLine("Content removed");
            Console.WriteLine(applicationId);
            Console.WriteLine(sideShowEndpointId);
            Console.WriteLine(removedContentId);
        }

        public void Initialize()
        {
            Console.WriteLine("Initialize");
        }

        public void Deinitialize()
        {
            Console.WriteLine("Deinitialize");
        }

        #endregion
    }
}
